#include <stdio.h>
#include <stddef.h>
#include <string.h>
#ifdef __DOS__
#include "bfd_dos.h"
#else
#include "bfd.h"
#endif

void ShowType( char * t, int s )
{
	if( strncmp( t, "struct", 6 ) == 0 )
		printf( "%s: %d\n", t + 7, s );
	else
		printf( "%s: %d\n", t, s );
}

void ShowMember( char * t, char * m, int o )
{
	if( strncmp( t, "struct", 6 ) == 0 )
		printf( "    %s.%s: %d\n", t + 7, m, o );
	else
		printf( "    %s.%s: %d\n", t, m, o );
}

#define ST( A )    ShowType( #A, sizeof( A ) );
#define SM( A, B ) ShowMember( #A, #B, offsetof( A, B ) );

int main()
{

	ST( struct carsym )
	SM( struct carsym, name )
	SM( struct carsym, file_offset )

	ST( symbol_info )
	SM( symbol_info, value )
	SM( symbol_info, type )
	SM( symbol_info, name )
	SM( symbol_info, stab_type )
	SM( symbol_info, stab_other )
	SM( symbol_info, stab_desc )
	SM( symbol_info, stab_name )

	ST( struct bfd_hash_entry )
	SM( struct bfd_hash_entry, next )
	SM( struct bfd_hash_entry, string )
	SM( struct bfd_hash_entry, hash )

	ST( struct bfd_hash_table )
	SM( struct bfd_hash_table, table )
	SM( struct bfd_hash_table, size )
	SM( struct bfd_hash_table, entsize )
	SM( struct bfd_hash_table, newfunc )
	SM( struct bfd_hash_table, memory )

	ST( bfd_window )
	SM( bfd_window, data )
	SM( bfd_window, size )
	SM( bfd_window, i )

	ST( struct coff_comdat_info )
	SM( struct coff_comdat_info, name )
	SM( struct coff_comdat_info, symbol )

//	ST( asection_map )
//	SM( asection_map, link_order )
//	SM( asection_map, s )

	ST( struct bfd_section )
	SM( struct bfd_section, name )
	SM( struct bfd_section, id )
	SM( struct bfd_section, index )
	SM( struct bfd_section, next )
	SM( struct bfd_section, prev )
	SM( struct bfd_section, flags )
/*
	user_set_vma:1 as uinteger
	linker_mark:1 as uinteger
	linker_has_input:1 as uinteger
	gc_mark:1 as uinteger
	gc_mark_from_eh:1 as uinteger
	segment_mark:1 as uinteger
	sec_info_type:3 as uinteger
	use_rela_p:1 as uinteger
	has_tls_reloc:1 as uinteger
	has_gp_reloc:1 as uinteger
	need_finalize_relax:1 as uinteger
	reloc_done:1 as uinteger
*/
	SM( struct bfd_section, vma )
	SM( struct bfd_section, lma )
	SM( struct bfd_section, size )
	SM( struct bfd_section, rawsize )
	SM( struct bfd_section, output_offset )
	SM( struct bfd_section, output_section )
	SM( struct bfd_section, alignment_power )
	SM( struct bfd_section, relocation )
	SM( struct bfd_section, orelocation )
	SM( struct bfd_section, reloc_count )
	SM( struct bfd_section, filepos )
	SM( struct bfd_section, rel_filepos )
	SM( struct bfd_section, line_filepos )
	SM( struct bfd_section, userdata )
	SM( struct bfd_section, contents )
	SM( struct bfd_section, lineno )
	SM( struct bfd_section, lineno_count )
	SM( struct bfd_section, entsize )
	SM( struct bfd_section, kept_section )
	SM( struct bfd_section, moving_line_filepos )
	SM( struct bfd_section, target_index )
	SM( struct bfd_section, used_by_bfd )
	SM( struct bfd_section, constructor_chain )
	SM( struct bfd_section, owner )
	SM( struct bfd_section, symbol )
	SM( struct bfd_section, symbol_ptr_ptr )
	SM( struct bfd_section, map_head )
	SM( struct bfd_section, map_tail )

	return 0;

}
